--[[
============================================
LUAtris 0.1 by mikehaggar99(at)gmail(dot)com
============================================
]]

dofile("./font.lua")
dofile("./browser.lua")

color1 = {}
color2 = {}

background = Image.createEmpty(480, 272)
action = Image.createEmpty(480, 272)
piece = {{},{},{},{},{},{},{}}

board = {{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}}

color1[1] = Color.new(128, 0, 0)
color2[1] = Color.new(255, 0, 0)
color1[2] = Color.new(128, 64, 0)
color2[2] = Color.new(255, 128, 0)
color1[3] = Color.new(128, 128, 0)
color2[3] = Color.new(255, 255, 0)
color1[4] = Color.new(0, 128, 0)
color2[4] = Color.new(0, 255, 0)
color1[5] = Color.new(0, 128, 128)
color2[5] = Color.new(0, 255, 255)
color1[6] = Color.new(0, 0, 128)
color2[6] = Color.new(0, 0, 255)
color1[7] = Color.new(128, 0, 128)
color2[7] = Color.new(255, 0, 255)

piece[1][1] = {{0,0,0,0}, {0,0,1,0}, {0,0,1,1}, {0,0,1,0}}
piece[1][2] = {{0,0,0,0}, {0,0,1,0}, {0,1,1,1}, {0,0,0,0}}
piece[1][3] = {{0,0,0,0}, {0,0,1,0}, {0,1,1,0}, {0,0,1,0}}
piece[1][4] = {{0,0,0,0}, {0,0,0,0}, {0,1,1,1}, {0,0,1,0}}

piece[2][1] = {{0,0,0,0}, {0,0,1,1}, {0,0,1,1}, {0,0,0,0}}
piece[2][2] = {{0,0,0,0}, {0,0,1,1}, {0,0,1,1}, {0,0,0,0}}
piece[2][3] = {{0,0,0,0}, {0,0,1,1}, {0,0,1,1}, {0,0,0,0}}
piece[2][4] = {{0,0,0,0}, {0,0,1,1}, {0,0,1,1}, {0,0,0,0}}

piece[3][1] = {{0,0,0,0}, {0,0,1,0}, {0,0,1,1}, {0,0,0,1}}
piece[3][2] = {{0,0,0,0}, {0,0,0,0}, {0,0,1,1}, {0,1,1,0}}
piece[3][3] = {{0,0,0,0}, {0,0,1,0}, {0,0,1,1}, {0,0,0,1}}
piece[3][4] = {{0,0,0,0}, {0,0,0,0}, {0,0,1,1}, {0,1,1,0}}

piece[4][1] = {{0,0,1,0}, {0,0,1,0}, {0,0,1,0}, {0,0,1,0}}
piece[4][2] = {{0,0,0,0}, {0,0,0,0}, {1,1,1,1}, {0,0,0,0}}
piece[4][3] = {{0,0,1,0}, {0,0,1,0}, {0,0,1,0}, {0,0,1,0}}
piece[4][4] = {{0,0,0,0}, {0,0,0,0}, {1,1,1,1}, {0,0,0,0}}

piece[5][1] = {{0,0,0,0}, {0,0,1,0}, {0,0,1,0}, {0,0,1,1}}
piece[5][2] = {{0,0,0,0}, {0,0,0,1}, {0,1,1,1}, {0,0,0,0}}
piece[5][3] = {{0,0,0,0}, {0,1,1,0}, {0,0,1,0}, {0,0,1,0}}
piece[5][4] = {{0,0,0,0}, {0,0,0,0}, {0,1,1,1}, {0,1,0,0}}

piece[6][1] = {{0,0,0,0}, {0,0,1,1}, {0,0,1,0}, {0,0,1,0}}
piece[6][2] = {{0,0,0,0}, {0,1,0,0}, {0,1,1,1}, {0,0,0,0}}
piece[6][3] = {{0,0,0,0}, {0,0,1,0}, {0,0,1,0}, {0,1,1,0}}
piece[6][4] = {{0,0,0,0}, {0,0,0,0}, {0,1,1,1}, {0,0,0,1}}

piece[7][1] = {{0,0,0,0}, {0,0,0,1}, {0,0,1,1}, {0,0,1,0}}
piece[7][2] = {{0,0,0,0}, {0,1,1,0}, {0,0,1,1}, {0,0,0,0}}
piece[7][3] = {{0,0,0,0}, {0,0,0,1}, {0,0,1,1}, {0,0,1,0}}
piece[7][4] = {{0,0,0,0}, {0,1,1,0}, {0,0,1,1}, {0,0,0,0}}

blackColor = Color.new(0, 0, 0)
greyColor = Color.new(128, 128, 128)
whiteColor = Color.new(255, 255, 255)
customColor = Color.new(255, 255, 255)

newpiece = 0
newrotation = 0
currentpiece = 0
currentrotation = 0
positionx = 3
positiony = -2
rotation = 0
xstart = 0
xwidth = 0
ystart = 0
ywidth = 0
delay=0
padcross=0
padcircle=0
exit2=false
score=0
high=0
lines=0
level=0


function standardBack(x)
	if x==0 then
		background:fillRect(0, 0, 480, 272, blackColor)
		background:fillRect(170, 0, 140, 265, whiteColor)
		background:fillRect(175, 0, 130, 260, blackColor)
		background:fillRect(356, 51, 80, 80, whiteColor)
		background:fillRect(361, 56, 70, 70, blackColor)
		background:fillRect(10, 51, 150, 107, whiteColor)
		background:fillRect(15, 56, 140, 97, blackColor)
		background:print(354, 40, "NEXT PIECE:", whiteColor)
		customColor = whiteColor
	end

--	background:print(10, 10, "LUAtris 0.1", customColor)
--	background:print(10, 18, "mikehaggar99", customColor)
--	background:print(10, 26, "(at)gmail(dot)com", customColor)
	background:print(25, 66, "High:", customColor)
	background:print(25, 86, "Score:", customColor)
	background:print(25, 106, "Lines:", customColor)
	background:print(25, 126, "Level:", customColor)
end

function drawTile(piece, x, y)
	action:fillRect(x*13+175, y*13, 13, 13, color1[piece])
	action:fillRect((x*13)+177, (y*13)+2, 9, 9, color2[piece])
end


function textPrint()
	level=math.floor(lines/10)
	if level > 9 then
		level = 9
	end

	if high<score then
		high=score
	end
--	screen:print(10, 42, "DEBUG INFO:", whiteColor)
--	screen:print(10, 50, positionx.." "..xstart.." "..xwidth.." "..positiony.." "..ystart.." "..ywidth.." "..currentrotation.." "..rotation.." "..delay, whiteColor)
	screen:print(25, 76, string.format("%15d", high), customColor)
	screen:print(25, 96, string.format("%15d", score), customColor)
	screen:print(25, 116, string.format("%15d", lines), customColor)
	screen:print(25, 136, string.format("%15d", level), customColor)
end


function removeLines()
	finish=false
	for y_axis_1=0,19 do
		if board[1][y_axis_1+1] > 0 and board[2][y_axis_1+1] > 0 and board[3][y_axis_1+1] > 0 and board[4][y_axis_1+1] > 0 and board[5][y_axis_1+1] > 0 and board[6][y_axis_1+1] > 0 and board[7][y_axis_1+1] > 0 and board[8][y_axis_1+1] > 0 and board[9][y_axis_1+1] > 0 and board[10][y_axis_1+1] > 0 then
			board[1][y_axis_1+1]=-1
			board[2][y_axis_1+1]=-1
			board[3][y_axis_1+1]=-1
			board[4][y_axis_1+1]=-1
			board[5][y_axis_1+1]=-1
			board[6][y_axis_1+1]=-1
			board[7][y_axis_1+1]=-1
			board[8][y_axis_1+1]=-1
			board[9][y_axis_1+1]=-1
			board[10][y_axis_1+1]=-1
			score=score+100
			lines=lines+1
			finish = true
		end
	end

	if finish==true then
		action:clear()
		drawBoard()
		drawNext()
		screen:blit(0, 0, background)
		screen:blit(0, 0, action)
		textPrint()
		screen.waitVblankStart()
		screen.flip()
		screen.waitVblankStart(20)
		finish=false

		while finish==false do
			finish=true
			y_axis_1=19
			while y_axis_1>0 do
				if board[1][y_axis_1+1] == -1 and board[2][y_axis_1+1] == -1 and board[3][y_axis_1+1] == -1 and board[4][y_axis_1+1] == -1 and board[5][y_axis_1+1] == -1 and board[6][y_axis_1+1] == -1 and board[7][y_axis_1+1] == -1 and board[8][y_axis_1+1] == -1 and board[9][y_axis_1+1] == -1 and board[10][y_axis_1+1] == -1 then
					board[1][y_axis_1+1]=board[1][y_axis_1]
					board[2][y_axis_1+1]=board[2][y_axis_1]
					board[3][y_axis_1+1]=board[3][y_axis_1]
					board[4][y_axis_1+1]=board[4][y_axis_1]
					board[5][y_axis_1+1]=board[5][y_axis_1]
					board[6][y_axis_1+1]=board[6][y_axis_1]
					board[7][y_axis_1+1]=board[7][y_axis_1]
					board[8][y_axis_1+1]=board[8][y_axis_1]
					board[9][y_axis_1+1]=board[9][y_axis_1]
					board[10][y_axis_1+1]=board[10][y_axis_1]
					if y_axis_1>1 then
						board[1][y_axis_1]=-1
						board[2][y_axis_1]=-1
						board[3][y_axis_1]=-1
						board[4][y_axis_1]=-1
						board[5][y_axis_1]=-1
						board[6][y_axis_1]=-1
						board[7][y_axis_1]=-1
						board[8][y_axis_1]=-1
						board[9][y_axis_1]=-1
						board[10][y_axis_1]=-1
					else
						board[1][y_axis_1]=0
						board[2][y_axis_1]=0
						board[3][y_axis_1]=0
						board[4][y_axis_1]=0
						board[5][y_axis_1]=0
						board[6][y_axis_1]=0
						board[7][y_axis_1]=0
						board[8][y_axis_1]=0
						board[9][y_axis_1]=0
						board[10][y_axis_1]=0
					end
					finish=false
				end
				y_axis_1=y_axis_1-1
			end
		end
	end

	action:clear()
	drawBoard()
	drawNext()
	screen:blit(0, 0, background)
	screen:blit(0, 0, action)
	textPrint()
	screen.waitVblankStart()
	screen.flip()
	screen.waitVblankStart()
end


function drawBoard()
	for x_axis_1=0,9 do
		for y_axis_1=0,19 do
			if board[x_axis_1+1][y_axis_1+1] > 0 then
				drawTile(board[x_axis_1+1][y_axis_1+1], x_axis_1, y_axis_1)
			end
		end
	end
end


function drawNext()
	for x_axis_1=0,3 do
		for y_axis_1=0,3 do
			if piece[newpiece+1][newrotation+1][x_axis_1+1][y_axis_1+1] == 1 then
				drawTile(newpiece+1, x_axis_1+15, y_axis_1+4)
			end
		end
	end
end


function drawNew()
	for x_axis_1=0,3 do
		for y_axis_1=0,3 do
			if piece[currentpiece+1][currentrotation+1][x_axis_1+1][y_axis_1+1] == 1 then
				drawTile(currentpiece+1, x_axis_1+positionx, y_axis_1+positiony)
			end
			if piece[newpiece+1][newrotation+1][x_axis_1+1][y_axis_1+1] == 1 then
				drawTile(newpiece+1, x_axis_1+15, y_axis_1+4)
			end
		end
	end
	drawNext()
end

-- thanks to DesktopMan for this
function getWidth()
	xwidth=0
	ywidth=0

	xstart=3
	ystart=3
	
	if rotation < 0 then
		rotation=3
	end

	for x_axis_1=0,3 do
		for y_axis_1=0,3 do
			if piece[currentpiece+1][rotation+1][x_axis_1+1][y_axis_1+1] == 1 then
				if x_axis_1>xwidth then
					xwidth=x_axis_1
				end

				if y_axis_1>ywidth then
					ywidth=y_axis_1
				end

				if x_axis_1<xstart then
					xstart=x_axis_1
				end

				if y_axis_1<ystart then
					ystart=y_axis_1
				end
			end
		end
	end
end

-- thanks to DesktopMan for this
function pieceOk(x, y, rot)
	x = x+positionx
	y = y+positiony
	rotation = math.mod(rot+currentrotation,4)

	getWidth()

	if x+xstart<0 then
		return false
	end
	
	if x+xwidth>9 then
		return false
	end

	if y+ywidth>19 then
		return false
	end

	for x_axis_1=0,3 do
		for y_axis_1=0,3 do
			if piece[currentpiece+1][rotation+1][x_axis_1+1][y_axis_1+1] == 1 and positiony+y_axis_1>=0 then
				if board[x+x_axis_1+1][y+y_axis_1+1]>0 then
					return false
				end
			end
		end
	end
	return true
end

-- thanks to DesktopMan for this
function checkEnd()
	getWidth()
	for x_axis_1=0,3 do
		for y_axis_1=0,3 do
			if piece[currentpiece+1][currentrotation+1][x_axis_1+1][y_axis_1+1] == 1 then
				if positiony+y_axis_1<0 then
					return true
				elseif board[positionx+x_axis_1+1][positiony+y_axis_1+1]>0 then
					return true
				end
			end
		end
	end
	return false
end


function control()
	pad = Controls.read()
	if pad:select() then
		if Music.playing() then
			Music.stop()
		end
		exit2=true
		screen.waitVblankStart(10)
	end
	if pad:start() then
		screen:blit(0, 0, background)
		textPrint()
		screen:print(220, 128, "PAUSE", whiteColor)
		screen.waitVblankStart()
		screen.flip()
		screen.waitVblankStart(30)
		gostart=false
		repeat
			pad = Controls.read()
			if pad:start() then 
				gostart=true
			end
		until gostart==true
		screen.waitVblankStart(10)
	end
	if pad:triangle() then
		screen:save("screenshot.tga")
	end
	if pad:left() and pieceOk(-1, 0, 0) and pieceOk(0, 0, 0) then
		positionx = positionx-1
	elseif pad:right() and pieceOk(1, 0, 0) and pieceOk(0, 0, 0) then
		positionx = positionx+1
	end
	if pad:down() and pieceOk(0,1,0) and pieceOk(0, 0, 0) then
		positiony = positiony+1
		score=score+1
	end
	if pad:cross() and pieceOk(0,0,-1) and pieceOk(0, 0, 0) then
		if padcross==0 then
			currentrotation=math.mod(currentrotation-1,4)
			if currentrotation < 0 then
				currentrotation=3
			end
		end
		padcross=math.mod(padcross+1,4)
		padcircle=0
	elseif pad:circle() and pieceOk(0,0,1) and pieceOk(0, 0, 0) then
		if padcircle==0 then
			currentrotation=math.mod(currentrotation+1,4)
		end
		padcircle=math.mod(padcircle+1,4)
		padcross=0
	else
		padcircle=0
		padcross=0
	end
	if pad:l() then
		if Music.playing() then
			Music.stop()
		end
		fileid,filepath = browser({".mod",".s3m",".xm",".it"},"ms0:/psp/music",1,0,1,0)
		if fileid==false then
		else
			olddir=System.currentDirectory()
			System.currentDirectory(filepath)
			Music.playFile(fileid, true)
			System.currentDirectory(olddir)
		end
		screen.waitVblankStart(10)
	elseif pad:r() then
		filename,directory = browser({".png"},System.currentDirectory(),1,-1,1,0)
		if filename==false then
			standardBack(0)
		else
			background:blit(0, 0, Image.load(string.format("%s%s",directory,filename)))
			customColor=background:pixel(0, 0)
			standardBack(1)
		end
		screen.waitVblankStart(10)
	end
end


screen:clear()
printEdit(10, 20, "L", color2[1], screen, 0, 8)
printEdit(74, 20, "U", color2[2], screen, 0, 8)
printEdit(138, 20, "A", color2[3], screen, 0, 8)
printEdit(202, 20, "t", color2[4], screen, 0, 8)
printEdit(266, 20, "r", color2[5], screen, 0, 8)
printEdit(330, 20, "i", color2[6], screen, 0, 8)
printEdit(394, 20, "s", color2[7], screen, 0, 8)
printEdit(442, 68, "v0.1", whiteColor, screen, 0, 1)
printEdit(11, 92, "mikehaggar99(at)gmail(dot)com", whiteColor, screen, 0, 2)
printEdit(28, 209, "PRESS START", whiteColor, screen, 0, 5)
screen.waitVblankStart()
screen.flip()

while exit2==false do
	pad = Controls.read()
	if pad:start() then
		exit2=true
		screen.waitVblankStart(10)
	end
	if pad:triangle() then
		screen:save("screenshot.tga")
	end
end

math.randomseed(os.time())
currentpiece=math.random(0,6)
newpiece=math.random(0,6)
standardBack(0)
exit2=false

while exit2==false do
	control()
	action:clear()
	drawBoard()
	drawNew()
	screen:blit(0, 0, background)
	screen:blit(0, 0, action)
	textPrint()
	screen.waitVblankStart()
	screen.flip()

	if delay>10-level and pieceOk(0,1,0) and pieceOk(0,0,0) then
		positiony=positiony+1
		action:clear()
		drawBoard()
		drawNew()
		screen:blit(0, 0, background)
		screen:blit(0, 0, action)
		textPrint()
		screen.waitVblankStart()
		screen.flip()
		delay=0
	elseif pieceOk(0,1,0) and pieceOk(0,0,0) then
	elseif delay>10-level or delay>6 then
		if checkEnd() then
			ended=false
			screen:print(205, 129, "GAME OVER", blackColor)
			screen:print(204, 128, "GAME OVER", whiteColor)
			screen.waitVblankStart()
			screen.flip()
			while ended==false do
				pad = Controls.read()
				if pad:start() then
					ended=true
				end
			end
			screen.waitVblankStart(10)
			board = {{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}}
			newpiece=math.random(0,6)
			score=0
			lines=0
			level=0
		else
			for x_axis_1=0,3 do
				for y_axis_1=0,3 do
					if piece[currentpiece+1][rotation+1][x_axis_1+1][y_axis_1+1] == 1 then
						board[positionx+x_axis_1+1][positiony+y_axis_1+1]=currentpiece+1
					end
				end
			end
			removeLines()
		end
		currentrotation=0
		currentpiece=newpiece
		newpiece=math.random(0,6)
		positionx = 3
		positiony = -2
		delay=0
	end
	delay=delay+1
end
